//+------------------------------------------------------------------+
//|                                          AdoDB-001 MS SQL CE.mq4 |
//|                                   Copyright 2015, Eugene Lugovoy |
//|                                        http://www.fxcodexlab.com |
//| Test connections to MS SQL CE. Reaching limit (DEMO)             |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Eugene Lugovoy"
#property link      "http://www.fxcodexlab.com"
#property version   "1.00"
#property strict

#include <MQLAdoDB.mqh>

string INI;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
 string Provider, DataSource; // database credentials
 int DB1,DB2,DB3; // database identifiers
 
 Print (AdoDBVersion());

 INI = TerminalPath()+"\\MQL4\\Scripts\\MSSQLCE.ini";
 
 // reading database credentials from INI file
 Provider = ReadIni(INI, "SQLCE", "Provider");
 DataSource = ReadIni(INI, "SQLCE", "Database");

 Print ("Provider: ",Provider, ", Database: ", DataSource);
 
 // open database connection
 Print ("Connecting...");
 
 DB1 = MSSQLCEConnect(Provider, DataSource);
 
 if (DB1 == -1) { Print ("Connection failed! Error: "+AdoDBErrorDescription); } else { Print ("Connected! DBID#",DB1);}
 
 DB2 = MSSQLCEConnect(Provider, DataSource);
 
 if (DB2 == -1) { Print ("Connection failed! Error: "+AdoDBErrorDescription); } else { Print ("Connected! DBID#",DB2);}

 DB3 = MSSQLCEConnect(Provider, DataSource);
 
 if (DB3 == -1) { Print ("Connection failed! Error: "+AdoDBErrorDescription); } else { Print ("Connected! DBID#",DB3);}
 
 AdoDBDisconnect(DB3);
 AdoDBDisconnect(DB2);
 AdoDBDisconnect(DB1);
 Print ("All connections closed. Script done!");
   
}

int MSSQLCEConnect(string Provider, string Database)
{
 string cnn;
 cnn = "Provider="+Provider+";Data Source="+Database;
 return (AdoDBConnect(cnn));
}

//+------------------------------------------------------------------+
