//+------------------------------------------------------------------+
//|                                          AdoDB-002 MS SQL CE.mq4 |
//|                                   Copyright 2015, Eugene Lugovoy |
//|                                        http://www.fxcodexlab.com |
//| Table creation (DEMO)                                            |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Eugene Lugovoy."
#property link      "http://www.fxcodexlab.com"
#property version   "1.00"
#property strict

#include <MQLAdoDB.mqh>

string INI;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
 string Provider, DataSource; // database credentials
 int DB; // database identifiers
 
 Print (AdoDBVersion());

 INI = TerminalPath()+"\\MQL4\\Scripts\\MSSQLCE.ini";
 
 // reading database credentials from INI file
 Provider = ReadIni(INI, "SQLCE", "Provider");
 DataSource = ReadIni(INI, "SQLCE", "Database");

 Print ("Provider: ",Provider, ", Database: ", DataSource);
 
 // open database connection
 Print ("Connecting...");
 
 DB = MSSQLCEConnect(Provider, DataSource);
 
 if (DB == -1) { Print ("Connection failed! Error: "+AdoDBErrorDescription); } else { Print ("Connected! DBID#",DB);}
 
 string Query;
 Query = "DROP TABLE test_table";
 AdoDBExecute(DB, Query);
 
 Query = "CREATE TABLE test_table (id bigint, code nvarchar(50), start_date datetime)";
 if (AdoDBExecute(DB, Query))
    {
     Print ("Table `test_table` created.");
    }
 else
    {
     Print ("Table `test_table` cannot be created. Error: ", AdoDBErrorDescription);
    }
 
 
 AdoDBDisconnect(DB);
 Print ("Disconnected. Script done!");
}
//+------------------------------------------------------------------+

int MSSQLCEConnect(string Provider, string Database)
{
 string cnn;
 cnn = "Provider="+Provider+";Data Source="+Database;
 return (AdoDBConnect(cnn));
}
