//+------------------------------------------------------------------+
//|                                          AdoDB-003 MS SQL CE.mq4 |
//|                                   Copyright 2015, Eugene Lugovoy |
//|                                        http://www.fxcodexlab.com |
//| Inserting data (DEMO)                                            |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Eugene Lugovoy."
#property link      "http://www.fxcodexlab.com"
#property version   "1.00"
#property strict

#include <MQLAdoDB.mqh>

string INI;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
 string Provider, DataSource; // database credentials
 int DB; // database identifiers
 
 Print (AdoDBVersion());

 INI = TerminalPath()+"\\MQL4\\Scripts\\MSSQLCE.ini";
 
 // reading database credentials from INI file
 Provider = ReadIni(INI, "SQLCE", "Provider");
 DataSource = ReadIni(INI, "SQLCE", "Database");

 Print ("Provider: ",Provider, ", Database: ", DataSource);
 
 // open database connection
 Print ("Connecting...");
 
 DB = MSSQLCEConnect(Provider, DataSource);
 
 if (DB == -1) { Print ("Connection failed! Error: "+AdoDBErrorDescription); } else { Print ("Connected! DBID#",DB);}
 
 string Query;
 Query = "DROP TABLE test_table";
 AdoDBExecute(DB, Query);
 
 Query = "CREATE TABLE test_table (id bigint, code nvarchar(50), start_date datetime)";
 if (AdoDBExecute(DB, Query))
    {
     Print ("Table \"test_table\" created.");
     
     // Inserting data 1 row
     Query = "INSERT INTO test_table (id, code, start_date) VALUES ("+(string)AccountNumber()+",\'ACCOUNT\',\'"+TimeToStr(TimeLocal(), TIME_DATE|TIME_SECONDS)+"\')";
     if (AdoDBExecute(DB, Query))
        {
         Print ("Succeeded: ", Query);
        }
     else
        {
         Print ("Error: ", AdoDBErrorDescription);
         Print ("Query: ", Query);
        }
     
     // insert 3 rows
     Print ("Inserting 3 rows...");
     Query = "INSERT INTO test_table (id, code, start_date) VALUES (1,\'EURUSD\',\'2014.01.01 00:00:01\')";
     Print (Query);
     AdoDBExecute(DB, Query);
     Query = "INSERT INTO test_table (id, code, start_date) VALUES (2,\'EURJPY\',\'2014.01.02 00:02:00\')";
     Print (Query);
     AdoDBExecute(DB, Query);
     Query = "INSERT INTO test_table (id, code, start_date) VALUES (3,\'USDJPY\',\'2014.01.03 03:00:00\')";
     Print (Query);
     AdoDBExecute(DB, Query);

     Print ("Updating...");

     Query = "UPDATE test_table SET id = id + 1 WHERE id in (2,3)";
     if (AdoDBExecute(DB, Query))
        {
         Print ("Succeeded! 2 rows has been updated.");
        }
     else
        {
         Print ("Error of multiple statements: ", AdoDBErrorDescription);
        }
    }
 else
    {
     Print ("Table \"test_table\" cannot be created. Error: ", AdoDBErrorDescription);
    }
 
 AdoDBDisconnect(DB);
 Print ("Disconnected. Script done!");
}
//+------------------------------------------------------------------+

int MSSQLCEConnect(string Provider, string Database)
{
 string cnn;
 cnn = "Provider="+Provider+";Data Source="+Database;
 return (AdoDBConnect(cnn));
}
