//+------------------------------------------------------------------+
//|                                          AdoDB-004 MS SQL CE.mq4 |
//|                                   Copyright 2015, Eugene Lugovoy |
//|                                        http://www.fxcodexlab.com |
//| Select data from table (DEMO)                                    |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Eugene Lugovoy."
#property link      "http://www.fxcodexlab.com"
#property version   "1.00"
#property strict

#include <MQLAdoDB.mqh>

string INI;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
 string Provider, DataSource; // database credentials
 int DB; // database identifiers
 
 Print (AdoDBVersion());

 INI = TerminalPath()+"\\MQL4\\Scripts\\MSSQLCE.ini";
 
 // reading database credentials from INI file
 Provider = ReadIni(INI, "SQLCE", "Provider");
 DataSource = ReadIni(INI, "SQLCE", "Database");

 Print ("Provider: ",Provider, ", Database: ", DataSource);
 
 // open database connection
 Print ("Connecting...");
 
 DB = MSSQLCEConnect(Provider, DataSource);
 
 if (DB == -1) { Print ("Connection failed! Error: "+AdoDBErrorDescription); } else { Print ("Connected! DBID#",DB);}

 // executing SELECT statement
 string Query;
 int    i,Cursor;
 
 int      vId;
 string   vCode;
 datetime vStartTime;
 
 Query = "SELECT id, code, start_date FROM test_table";
 Cursor = AdoDBCursorOpen(DB, Query);
 i = 0;
 if (Cursor >= 0)
    {
     while (AdoDBCursorFetchRow(Cursor))
            {
             vId = AdoDBGetFieldAsInt(Cursor, 0); // id
             vCode = AdoDBGetFieldAsString(Cursor, 1); // code
             vStartTime = AdoDBGetFieldAsDatetime(Cursor, 2); // start_time
             Print ("ROW[",i,"]: id = ", vId, ", code = ", vCode, ", start_time = ", TimeToStr(vStartTime, TIME_DATE|TIME_SECONDS));
             i=i+1;
            }
     AdoDBCursorClose(Cursor); // NEVER FORGET TO CLOSE CURSOR !!!
     Print (i, " row(s) selected.");
    }
 else
    {
     Print ("Cursor opening failed. Error: ", AdoDBErrorDescription,", code: ",AdoDBErrorNumber);
    }
    
 AdoDBDisconnect(DB);
 Print ("Disconnected. Script done!");
}
//+------------------------------------------------------------------+

int MSSQLCEConnect(string Provider, string Database)
{
 string cnn;
 cnn = "Provider="+Provider+";Data Source="+Database+";Mode=ReadWrite";
 return (AdoDBConnect(cnn));
}
