//+------------------------------------------------------------------+
//|                                          AdoDB-005 MS SQL CE.mq4 |
//|                                   Copyright 2015, Eugene Lugovoy |
//|                                        http://www.fxcodexlab.com |
//| Reaching cursors limit (DEMO)                                    |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Eugene Lugovoy."
#property link      "http://www.fxcodexlab.com"
#property version   "1.00"
#property strict

#include <MQLAdoDB.mqh>

string INI;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
 string Provider, DataSource; // database credentials
 int DB; // database identifiers
 
 Print (AdoDBVersion());

 INI = TerminalPath()+"\\MQL4\\Scripts\\MSSQLCE.ini";
 
 // reading database credentials from INI file
 Provider = ReadIni(INI, "SQLCE", "Provider");
 DataSource = ReadIni(INI, "SQLCE", "Database");

 Print ("Provider: ",Provider, ", Database: ", DataSource);
 
 // open database connection
 Print ("Connecting...");
 
 DB = MSSQLCEConnect(Provider, DataSource);
 
 if (DB == -1) { Print ("Connection failed! Error: "+AdoDBErrorDescription); } else { Print ("Connected! DBID#",DB);}
 
 string Query;
 int Cursor1, Cursor2, Cursor3, Cursor4;
 Query = "SELECT TOP 1 * FROM test_table";

 Cursor1 = AdoDBCursorOpen(DB, Query);
 if (Cursor1 >= 0) {Print ("Cursor 1 was opened.");} else {Print ("Cursor 1 failed. Error: ", AdoDBErrorDescription);}
 Cursor2 = AdoDBCursorOpen(DB, Query);
 if (Cursor2 >= 0) {Print ("Cursor 2 was opened.");} else {Print ("Cursor 2 failed. Error: ", AdoDBErrorDescription);}
 Cursor3 = AdoDBCursorOpen(DB, Query);
 if (Cursor3 >= 0) {Print ("Cursor 3 was opened.");} else {Print ("Cursor 3 failed. Error: ", AdoDBErrorDescription);}
 Cursor4 = AdoDBCursorOpen(DB, Query);
 if (Cursor4 >= 0) {Print ("Cursor 4 was opened.");} else {Print ("Cursor 4 failed. Error: ", AdoDBErrorDescription);}
 
 Print ("Closing cursors...");
 AdoDBCursorClose(Cursor1);
 AdoDBCursorClose(Cursor2);
 AdoDBCursorClose(Cursor3);
 AdoDBCursorClose(Cursor4);
 Print ("Passed!");
 
 AdoDBDisconnect(DB);
 Print ("Disconnected. Script done!");
}
//+------------------------------------------------------------------+

int MSSQLCEConnect(string Provider, string Database)
{
 string cnn;
 cnn = "Provider="+Provider+";Data Source="+Database+";Mode=ReadWrite";
 return (AdoDBConnect(cnn));
}
